var Q, _, redis, redisMethods;

redis = require('ioredis');

_ = require('lodash');

Q = require('q');

redisMethods = class redisMethods {
  constructor(_config) {
    var _host, _options, _port, config;
    config = _.cloneDeep(_config);
    _host = config.host || null;
    _port = config.port || null;
    delete config.host;
    delete config.port;
    _options = config || null;
    this.client = new redis(_port, _host, _options);
  }

  set(key, row, ttl) {
    if (!ttl) {
      return this.client.set(key, row);
    } else {
      return this.client.set(key, row, 'EX', ttl);
    }
  }

  get(keys) {
    var arr, arrayToObj;
    arr = keys;
    if (Object.prototype.toString.call(keys) !== '[object Array]') {
      arr = [keys];
    }
    arrayToObj = function(keys, vals) {
      var i, j, key, len, obj;
      obj = {};
      for (i = j = 0, len = keys.length; j < len; i = ++j) {
        key = keys[i];
        if (vals[i] != null) {
          obj[key] = vals[i];
        }
      }
      return obj;
    };
    return this.client.mget(arr).then(function(rows) {
      return Q(arrayToObj(arr, rows));
    });
  }

  del(keys, callback) {
    return this.client.del(keys);
  }

  end() {
    return this.client.quit();
  }

};

module.exports = redisMethods;
